void far *xmscall;
int xmsver;

// 0=Error, other=OK

xms_init()
    {
    UINT s,o;
    printf("Testing for XMS... ");
    _asm
        {
        mov ax, 4300h
        int 2Fh
        cmp al, 80h
        jnz noxms
        mov ax, 4310h
        int 2Fh
        mov ax, es
        mov s, ax
        mov o, bx
        }
    xmscall = MK_FP(s,o);
    _asm
        {
        mov ah, 0
        call xmscall
        mov o, ax
        mov s, bx
        }
    printf("Found V%i.%i (%i)\n",o / 256,o % 256,s);
    return 1;
    noxms:
    puts("ERROR");
    return 0;
    }

xms_alloc(unsigned kb)
    {
    UINT i,j;
    if(xmscall == NULL) return 0;
    _asm
        {
        mov ah, 9h
        mov dx, kb
        call xmscall
        mov i, ax
        mov j, dx
        }
    return i ? j : 0;
    }

xms_free(int handle)
    {
    if(xmscall == NULL) return 0;
    _asm
        {
        mov ah, 0ah
        mov dx, handle
        call xmscall
        }
    }

unsigned long fp2ulng(void *fp)
    {
    unsigned long x;
    ((unsigned *) &x)[0] = FP_OFF(fp);
    ((unsigned *) &x)[1] = FP_SEG(fp);
    return x;
    }

xms_copy(unsigned long length, int srchnd, unsigned long srcoff, int dsthnd, unsigned long dstoff)
    {
    struct { unsigned long length; int srchnd; unsigned long srcoff; int dsthnd; unsigned long dstoff; } dat;
    UINT s=FP_SEG(dat),o=FP_OFF(dat);
    if(xmscall == NULL) return 0;
    dat.length = length;
    dat.srchnd = srchnd;
    dat.srcoff = srcoff;
    dat.dsthnd = dsthnd;
    dat.dstoff = dstoff;
    _asm
        {
        mov ax, s
        mov ds, ax
        mov ah, 0bh
        mov si, o;
        call xmscall
        mov o, ax
        }
    return !o;
    }

xms_copy2(unsigned long length, int srchnd, unsigned long srcoff, int dsthnd, unsigned long dstoff)
    {
    char bufa[2],bufb[2];
    if(length == 1)
        {
        xms_copy(2,srchnd,srcoff,0,(unsigned long) bufa);
        xms_copy(2,dsthnd,dstoff,0,(unsigned long) bufb);
        bufb[0] = bufa[0];
        xms_copy(2,0,(unsigned long) bufb,dsthnd,dstoff);
        }
    else
        {
        xms_copy(length & 0xF7,srchnd,srcoff,dsthnd,dstoff);
        if(length & 1)
            xms_copy(2,srchnd,srcoff+(length & 0xF7)-2,dsthnd,dstoff+(length & 0xF7)-2);
        }
    }

#define localtoxms(len,src,dsthnd,dstoff) xms_copy2((len),0,fp2ulng(src),dsthnd,dstoff)
#define xmstolocal(len,srchnd,srcoff,dst) xms_copy2((len),srchnd,srcoff,0,fp2ulng(dst))
#define xmstoxms(len,srchnd,srcoff,dsthnd,dstoff) xms_copy2(len,srchnd,srcoff,dsthnd,dstoff)

